from Plugins.Plugin import PluginDescriptor
from Components.ActionMap import ActionMap
from Components.MenuList import MenuList
from Components.Label import Label
from Screens.Screen import Screen
from Screens.Console import Console
from Screens.MessageBox import MessageBox
from enigma import getDesktop
import subprocess, threading, os

sz_w = getDesktop(0).size().width()

transmission_sh = "systemctl"
hyperiongrabbertoggle_version = "1.1b"

class HyperionGrabberToggle(Screen):
	if sz_w == 1920:
		skin = """
		<screen position="center,center" size="750,630" title="Hyperion Grabber Toggle" >
			<eLabel font="Regular;30" foregroundColor="white" name="" position="5,570" size="140,40" text="Exit" valign="center" halign="center" backgroundColor="#9f1313" shadowColor="black" shadowOffset="-2,-2" transparent="1" />
			<widget name="menu" position="10,10" size="730,330" scrollbarMode="showOnDemand" />
			<widget name="status" position="10,350" size="730,150" font="Regular;23" foregroundColor="black" backgroundColor="white" />
			<eLabel name="" position="10,550" size="730,2" backgroundColor="grey" />
		</screen>"""
	else:
		skin = """
		<screen position="center,center" size="450,430" title="Hyperion Grabber Toggle" >
			<eLabel font="Regular;22" foregroundColor="white" name="" position="5,370" size="140,40" text="Exit" valign="center" halign="center" backgroundColor="#9f1313" shadowColor="black" shadowOffset="-2,-2" transparent="1" />
			<widget name="menu" position="10,10" size="450,150" scrollbarMode="showOnDemand" />
			<widget name="status" position="10,170" size="430,150" font="Regular;23" foregroundColor="black" backgroundColor="white" />
			<eLabel name="" position="10,350" size="430,2" backgroundColor="grey" />
		</screen>"""
	
	def __init__(self, session, args=None):
		Screen.__init__(self, session)
		self["status"] = Label(_("state:"))
		self.session = session
		self.menu = args
		list = []
		list.append((_("hyperion-aml"), "restart_aml"))
		list.append((_("hyperion-v4l2"), "restart_v4l2"))
		list.append((_("Info Hyperion Grabber Toggle"), "about_hyperioncontrolv4l2"))
		self["menu"] = MenuList(list)
		self["actions"] = ActionMap(["OkCancelActions"], {"ok": self.run, "cancel": self.close}, -1)
		self.onShown.append(self.refreshStatus)
		
	def run(self):
		returnValue = self["menu"].l.getCurrentSelection()[1]
        	if returnValue is not None:
			if returnValue is "restart_aml":
				self.session.open(Console,_("restart hyperionaml"),["%s restart hyperionaml" % transmission_sh])
			elif returnValue is "restart_v4l2":
				self.session.open(Console,_("restart hyperion-v4l2"),["%s restart hyperion-v4l2" % transmission_sh])
			elif returnValue is "about_hyperioncontrolv4l2":
				title="Hyperion Grabber Toggle version %s \n\nStarten, Restarten, Umschalten\nhyperion-aml - interner Amlogic Grabber\nhyperion-v4l2 -externer USB Grabber\n\nplugin by pclin" % hyperiongrabbertoggle_version
				self.session.open(MessageBox,("%s") % (title),  MessageBox.TYPE_INFO)
		
	def refreshStatus(self):
		status_txt = "\n  " + _("state:") + "\n"
		
		#hyperion-v4l2-status
		command = Command("systemctl status hyperion-v4l2")
		command.run(timeout=3)
		cmd_out= command.out
		if "Active: active" in cmd_out:
			status_txt += "  Hyperion-v4l2: %s\n" % _("active")
		else:
			status_txt += "  Hyperion-v4l2: %s\n" % _("inactive")
		
		#hyperionaml-status
		command = Command("systemctl status hyperionaml")
		command.run(timeout=3)
		cmd_out= command.out
		aml_active = False
		if "Active: active" in cmd_out:
			status_txt += "  Hyperion-aml: %s\n" % _("active")
			aml_active = True
		else:
			status_txt += "  Hyperion-aml: %s\n" % _("inactive")
		
		self["status"].setText(status_txt)
		
	def layoutFinished(self):
		self.setTitle(_("Hyperion Control"))

		
#to get consolen-output with timeout-function
class Command(object):
	def __init__(self, cmd):
		self.cmd = cmd
		self.process = None

	def run(self, timeout):
		def target():
			self.process = subprocess.Popen(self.cmd, shell=True, stdout=subprocess.PIPE, stderr=subprocess.PIPE)
			(self.out,self.err) = self.process.communicate()

		thread = threading.Thread(target=target)
		thread.start()
		self.timeout=False

		thread.join(float(timeout))
		if thread.is_alive():
			self.process.terminate()
			self.timeout=True
			self.process = None
			thread = None
			return
		
def main(session, **kwargs):
	session.open(HyperionGrabberToggle)

def Plugins(path,**kwargs):
    return [PluginDescriptor(
        name=_("Hyperion Grabber Toggle"), 
        description = _("Umschaltung interner/externer Grabber (v%s)") % hyperiongrabbertoggle_version,
        where = PluginDescriptor.WHERE_PLUGINMENU,icon="hyperiongrabbertoggle.png",
        fnc = main
        ),
	PluginDescriptor(name=_("HyperionGrabberToggle"), where = PluginDescriptor.WHERE_EXTENSIONSMENU, fnc=main)]
